name: "nergi_classflaw"
revision: 5
description: "model: flaws_64x64x3_c32_c64_c64_f128_f128_o5_20160811 (5-classes: lab0 negative; lab1 stalk/calyx; lab2 well-defined holes; lab3 rust; lab4 undefined/uncertain flaws)"

stages {
  name: "item"
  type: SOURCE_CUSTOM
#  custom_param {
#    proxy: "test:ConcatCustomSource"
#    args: "nergi_segmentation.apl"
#  }
}

# Bounding-box resizing: fixed the width the height is set automatically
stages {
  name: "item_normalized"
  type: RESIZE
  input: "item"
  resize_param {
    width: 204
  }
}

stages {
  name: "bb_normalized_novalues"
  type: JOIN
  input: "item_normalized"
}

stages {
  name: "bb_normalized"
  type: RANDOM_CLASSIFIER
  input: "bb_normalized_novalues"
  random_classifier_param {
  }
}

stages {
  name: "flaw_all"
  type: NEURAL_NETWORK
  input: "item_normalized"
  neural_network_param {
    # deploy: "models/flaws_64x64x3_c32_c64_c64_f128_f128_o5_20160811/deploy.prototxt"
    deploy: "models/flaws_64x64x3_c32_c64_c64_f128_f128_o3_20160902/deploy.prototxt"
    # model: "models/flaws_64x64x3_c32_c64_c64_f128_f128_o5_20160811/net_iter_199000.caffemodel"
    model: "models/flaws_64x64x3_c32_c64_c64_f128_f128_o3_20160902/net_iter_287000.caffemodel"
    scale: 0.00390625

    # fully_deploy: "models/flaws_64x64x3_c32_c64_c64_f128_f128_o5_20160811/deploy_fully.prototxt"
    fully_deploy: "models/flaws_64x64x3_c32_c64_c64_f128_f128_o3_20160902/deploy_fully.prototxt"
    fully_subst_layers: "fc4 => fc4-conv, fc5 => fc5-conv, fc6 => fc6-conv"
    fully_cluster: true

    gpu: true
    encrypted: false
  }
}

stages {
  name: "stalk_filter"
  type: CLASS_FILTER
  input: "flaw_all"
  class_filter_param {
    default_policy: CLASS_REJECT
    value_threshold: 0.95
    class_include: "1"
  }
}

stages {
  name: "stalk_hidden"
  type: RANKING
  input: "stalk_filter"
  ranking_param {
    class_rank_def: "1:1"
    group_by_root: true
  }
}

stages {
  name: "stalk"
  type: JOIN
  input: "stalk_hidden"
}

stages {
  name: "caliper"
  type: CALIPER
  input: "item"
  input: "stalk_hidden"
  caliper_param {
    cross_major_axis: true
    #simmetry_ratio: 0.85
    #correction_policy: ZERO
  }
}

stages {
  name: "flaw_candidate"
  type: RANKING
  input: "flaw_all"
  ranking_param {
    class_rank_def: "0:0, 1:0"
    group_by_root: true
  }
}

stages {
  name: "flaw"
  type: CLASS_FILTER
  input: "flaw_candidate"
  class_filter_param {
    value_threshold: 0.95
  }
}
